diff -ruN ../nakedmudv2.1.1/src/char_gen.c src/char_gen.c
--- ../nakedmudv2.1.1/src/char_gen.c	Wed Dec 31 17:00:00 1969
+++ src/char_gen.c	Thu May 12 17:08:51 2005
@@ -0,0 +1,191 @@
+//*****************************************************************************
+//
+// char_gen.c
+//
+// Contains all of the functions neccessary for generating a new character. 
+// Different muds will handle this process in wildly different ways. As such,
+// I figured it would be good to localize all of the login details to a single 
+// file for people to tailor to their specific mud. It also makes updating to 
+// newer versions a bit easier. Your character generation process should be
+// laid out here. A basic framework is given, but it could use lots of work. In
+// fact, it is crap and could use LOTS of work. I encourage people to write 
+// their own login procedure and submit their designs to me so I can develop a 
+// better general method for later versions of the mud.
+//
+//*****************************************************************************
+
+#include "mud.h"
+#include "utils.h"
+#include "socket.h"
+#include "account.h"
+#include "character.h"
+#include "world.h"
+#include "save.h"
+#include "races.h"
+#include "handler.h"
+#include "inform.h"
+
+
+
+//*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "scripts/script.h"
+
+
+
+//*****************************************************************************
+// local functions, defines, structures, and the like
+//*****************************************************************************
+
+// functions in the char creation procedure
+void char_ask_name(SOCKET_DATA *sock, char *arg);
+void char_ask_sex (SOCKET_DATA *sock, char *arg);
+void char_ask_race(SOCKET_DATA *sock, char *arg);
+
+
+//
+// List all of the races available during creation
+void list_races(SOCKET_DATA *sock) {
+  send_to_socket(sock, "Available races are:\r\n");
+  send_to_socket(sock, "%s", raceGetList(TRUE));
+  send_to_socket(sock, "\r\n\r\nPlease enter your choice: ");
+}
+
+
+//
+// Character names must be at least 4 characters long, and no more than 12.
+// The name must only be composed of alphanumeric characters
+bool check_char_name(const char *name) {
+  int i, size = strlen(name);
+  if (size < 3 || size > 12)
+    return FALSE;
+  for (i = 0; i < size; i++)
+    if (!isalpha(name[i])) 
+      return FALSE;
+  return TRUE;
+}
+
+
+//
+// Query for the character's name.
+void char_ask_name(SOCKET_DATA *sock, char *arg) {
+  CHAR_DATA *ch = NULL;
+
+  // check for a legal name
+  if(!check_char_name(arg))
+    text_to_buffer(sock, 
+		   "Sorry, that was an illegal name. Please pick another.\r\n"
+		   "What is your name? ");
+  // a character with this name already exists
+  else if(char_exists(arg))
+    text_to_buffer(sock,
+		   "A character with this name already exists.\r\n"
+		   "What is your name? ");
+  // we're OK to make this new character
+  else {
+    ch = newChar();
+
+    // give the player it's name 
+    *arg = toupper(*arg);
+    charSetName(ch, arg);
+
+    // and room description. In the future, we may want
+    // to consider allowing players to set their own rdescs 
+    char rdesc[SMALL_BUFFER];
+    sprintf(rdesc, "%s is here.", arg);
+    charSetRdesc(ch, rdesc);
+
+    // socket <-> player 
+    charSetSocket(ch, sock);
+    socketSetChar(sock, ch);
+
+    // prepare for next step 
+    text_to_buffer(sock, "What is your sex (M/F/N)? ");
+    socketReplaceInputHandler(sock, char_ask_sex, NULL);
+  }
+}
+
+
+//
+// Ask for the character's sex. 
+void char_ask_sex (SOCKET_DATA *sock, char *arg) {
+  switch(toupper(*arg)) {
+  case 'F':
+    charSetSex(socketGetChar(sock), SEX_FEMALE);
+    break;
+  case 'M':
+    charSetSex(socketGetChar(sock), SEX_MALE);
+    break;
+  case 'N':
+    charSetSex(socketGetChar(sock), SEX_NEUTRAL);
+    break;
+  default:
+    text_to_buffer(sock, "\r\nInvalid sex. Try again (M/F/N) :");
+    return;
+  }
+
+  // onto race choosing
+  socketReplaceInputHandler(sock, char_ask_race, NULL);
+  list_races(sock);
+}
+
+
+//
+// Pick a race for our new character
+void char_ask_race(SOCKET_DATA *sock, char *arg) {
+  if(!arg || !*arg || !raceIsForPC(arg))
+    send_to_socket(sock, "Invalid race! Please try again: ");
+  else {
+    charSetRace(socketGetChar(sock), arg);
+    charResetBody(socketGetChar(sock));
+
+    // give the character a unique id 
+    int next_char_uid = mudsettingGetInt("puid") + 1;
+    mudsettingSetInt("puid", next_char_uid);
+    charSetUID(socketGetChar(sock), next_char_uid);
+    
+    // if it's the first player, set him as the highest level 
+    if(charGetUID(socketGetChar(sock)) == 1)
+      charSetLevel(socketGetChar(sock), MAX_LEVEL);
+
+    // add the character to the game 
+    char_to_game(socketGetChar(sock));
+    
+    log_string("New player: %s has entered the game.", 
+	       charGetName(socketGetChar(sock)));
+    
+    // and into the game 
+    // pop the input handler for char creation and add the one for
+    // playing the game
+    socketReplaceInputHandler(sock, handle_cmd_input, show_prompt);
+    text_to_buffer(sock, motd);
+    
+    // we should do some checks here to make sure the start room exists
+    char_to_room(socketGetChar(sock), worldGetRoom(gameworld, START_ROOM));
+    look_at_room(socketGetChar(sock), charGetRoom(socketGetChar(sock)));
+    
+    // and save him 
+    save_player(socketGetChar(sock));
+    
+    //************************************************************
+    //******                 VERY IMPORTANT                 ******
+    //************************************************************
+    // add this character to our account list
+    accountPutChar(socketGetAccount(sock), charGetName(socketGetChar(sock)));
+    save_account(socketGetAccount(sock));
+
+    // check enterance scripts
+    try_enterance_script(socketGetChar(sock), charGetRoom(socketGetChar(sock)), NULL);
+  }
+}
+
+
+
+//*****************************************************************************
+// implementation of char_gen.c
+//*****************************************************************************
+void start_char_gen(SOCKET_DATA *sock) {
+  text_to_buffer(sock, "What is your character's name? ");
+  socketPushInputHandler(sock, char_ask_name, NULL);
+}
diff -ruN ../nakedmudv2.1.1/src/char_gen.d src/char_gen.d
--- ../nakedmudv2.1.1/src/char_gen.d	Wed Dec 31 17:00:00 1969
+++ src/char_gen.d	Thu May 12 17:17:51 2005
@@ -0,0 +1,3 @@
+char_gen.d char_gen.o: char_gen.c mud.h wrapsock.h property_table.h list.h map.h \
+  hashtable.h set.h buffer.h bitvector.h utils.h socket.h account.h \
+  character.h world.h save.h races.h handler.h inform.h scripts/script.h
diff -ruN ../nakedmudv2.1.1/src/char_gen.h src/char_gen.h
--- ../nakedmudv2.1.1/src/char_gen.h	Wed Dec 31 17:00:00 1969
+++ src/char_gen.h	Thu May 12 17:08:51 2005
@@ -0,0 +1,23 @@
+#ifndef CHAR_GEN_H
+#define CHAR_GEN_H
+//*****************************************************************************
+//
+// char_gen.h
+//
+// Contains all of the functions neccessary for generating a new character. 
+// Different muds will handle this process in wildly different ways. As such,
+// I figured it would be good to localize all of the login details to a single 
+// file for people to tailor to their specific mud. It also makes updating to 
+// newer versions a bit easier. Your character generation process should be
+// laid out here. A basic framework is given, but it could use lots of work. In
+// fact, it is crap and could use LOTS of work. I encourage people to write 
+// their own login procedure and submit their designs to me so I can develop a 
+// better general method for later versions of the mud.
+//
+//*****************************************************************************
+
+//
+// Start the character generation process!
+void start_char_gen(SOCKET_DATA *sock);
+
+#endif // CHAR_GEN_H
diff -ruN ../nakedmudv2.1.1/src/character.c src/character.c
--- ../nakedmudv2.1.1/src/character.c	Sun May  8 15:04:44 2005
+++ src/character.c	Thu May 12 17:08:51 2005
@@ -90,7 +90,6 @@
 
 struct char_data {
   // data for PCs only
-  char                 * password;
   room_vnum              loadroom;
   int                    imm_invis;
 
@@ -125,10 +124,8 @@
 
 
 CHAR_DATA *newChar() {
-  CHAR_DATA *ch   = malloc(sizeof(CHAR_DATA));
-  bzero(ch, sizeof(*ch));
+  CHAR_DATA *ch   = calloc(1, sizeof(CHAR_DATA));
 
-  ch->password      = strdup("");
   ch->imm_invis     = 0;
 
   ch->loadroom      = NOWHERE;
@@ -214,10 +211,6 @@
   return ch->name;
 };
 
-const char  *charGetPassword  ( CHAR_DATA *ch) {
-  return ch->password;
-};
-
 const char  *charGetDesc      ( CHAR_DATA *ch) {
   return bufferString(ch->desc);
 }
@@ -259,7 +252,7 @@
   return ch->race;
 }
 
-int          charGetUID   ( CHAR_DATA *ch) {
+int          charGetUID   ( const CHAR_DATA *ch) {
   return ch->uid;
 }
 
@@ -296,11 +289,6 @@
   ch->name = strdup(name ? name : "");
 };
 
-void         charSetPassword  ( CHAR_DATA *ch, const char *password) {
-  if(ch->password) free(ch->password);
-  ch->password = strdup(password ? password : "");
-};
-
 void         charSetLevel     ( CHAR_DATA *ch, int level) {
   ch->level = level;
 };
@@ -371,7 +359,6 @@
   // it's also assumed we've extracted our inventory
   deleteList(mob->inventory);
 
-  if(mob->password)    free(mob->password);
   if(mob->name)        free(mob->name);
   if(mob->desc)        deleteBuffer(mob->desc);
   if(mob->rdesc)       free(mob->rdesc);
@@ -398,11 +385,10 @@
   charSetLevel(mob,        read_int   (set, "level"));
   charSetSex(mob,          read_int   (set, "sex"));
   charSetRace(mob,         read_string(set, "race"));
-  charSetPassword(mob,     read_string(set, "password"));
   bitSet(mob->prfs,        read_string(set, "prfs"));
 
-  // read in PC data
-  if(*charGetPassword(mob)) {
+  // read in PC data if it exists
+  if(storage_contains(set, "uid")) {
     charSetImmInvis(mob,   read_int   (set, "imm_invis"));
     charSetUID(mob,        read_int   (set, "uid"));
     charSetLoadroom(mob,   read_int   (set, "loadroom"));
@@ -447,7 +433,6 @@
   if(!charIsNPC(mob)) {
     store_int   (set, "imm_invis",  mob->imm_invis);
     store_int   (set, "position",   mob->position);
-    store_string(set, "password",   mob->password);
     store_int   (set, "uid",        mob->uid);
     store_int   (set, "loadroom",   roomGetVnum(charGetRoom(mob)));
   }
diff -ruN ../nakedmudv2.1.1/src/character.h src/character.h
--- ../nakedmudv2.1.1/src/character.h	Sun May  8 15:04:44 2005
+++ src/character.h	Thu May 12 17:08:51 2005
@@ -64,7 +64,6 @@
 ROOM_DATA   *charGetRoom      ( CHAR_DATA *ch);
 const char  *charGetName      ( CHAR_DATA *ch);
 const char  *charGetDesc      ( CHAR_DATA *ch);
-const char  *charGetPassword  ( CHAR_DATA *ch);
 const char  *charGetRdesc     ( CHAR_DATA *ch);
 const char  *charGetMultiRdesc( CHAR_DATA *ch);
 const char  *charGetMultiName ( CHAR_DATA *ch);
@@ -75,10 +74,10 @@
 LIST        *charGetInventory ( CHAR_DATA *ch);
 BODY_DATA   *charGetBody      ( CHAR_DATA *ch);
 const char  *charGetRace      ( CHAR_DATA *ch);
-int          charGetUID       ( CHAR_DATA *ch);
 room_vnum    charGetLoadroom  ( CHAR_DATA *ch);
 OBJ_DATA    *charGetFurniture ( CHAR_DATA *ch);
 int          charGetPos       ( CHAR_DATA *ch);
+int          charGetUID       ( const CHAR_DATA *ch);
 void        *charGetAuxiliaryData(const CHAR_DATA *ch, const char *name);
 int          charGetImmInvis  ( CHAR_DATA *ch);
 BITVECTOR   *charGetPrfs      ( CHAR_DATA *ch);
@@ -87,7 +86,6 @@
 void         charSetSocket    ( CHAR_DATA *ch, SOCKET_DATA *socket);
 void         charSetRoom      ( CHAR_DATA *ch, ROOM_DATA *room);
 void         charSetName      ( CHAR_DATA *ch, const char *name);
-void         charSetPassword  ( CHAR_DATA *ch, const char *password);
 void         charSetLevel     ( CHAR_DATA *ch, int level);
 void         charSetSex       ( CHAR_DATA *ch, int sex);
 void         charSetDesc      ( CHAR_DATA *ch, const char *desc);
diff -ruN ../nakedmudv2.1.1/src/cmd_admin.c src/cmd_admin.c
--- ../nakedmudv2.1.1/src/cmd_admin.c	Sun May  8 15:04:44 2005
+++ src/cmd_admin.c	Thu May 12 17:08:51 2005
@@ -20,9 +20,74 @@
 #include "storage.h"
 
 
+
+//*****************************************************************************
+// commands in cmd_admin.c
+//*****************************************************************************
+
+//
+// Locks the game for anyone at or below the lockdown level. No argument tells
+// us the current lockdown level. Suggested by Rhaelar
+COMMAND(cmd_lockdown) {
+  int lockdown = 0;
+
+  // we're trying to view the current lockdown level
+  if(!*arg) {
+    lockdown = mudsettingGetInt("lockdown");
+    // no lockdown in place
+    if(lockdown == 0)
+      send_to_char(ch, "The mud currently is not locked to anyone.\r\n");
+    else if(lockdown == 1)
+      send_to_char(ch, "The mud is locked down to new players.\r\n");
+    else
+      send_to_char(ch, "The mud is locked to anyone below level %d.\r\n",
+		   lockdown);
+  }
+
+  // make sure we've got a level number
+  else if(!isdigit(*arg))
+    send_to_char(ch, "Which level would you like to set the lockdown to?\r\n");
+
+  // make sure we don't lock ourself out
+  else if( (lockdown = atoi(arg)) > charGetLevel(ch))
+    send_to_char(ch, "You cannot lock out people below that level!\r\n");
+
+  // do the lockdown
+  else {
+    mudsettingSetInt("lockdown", lockdown);
+    if(lockdown == 0)
+      send_to_char(ch, "Lockdown removed.\r\n");
+    else if(lockdown == 1)
+      send_to_char(ch, "New players are locked down.\r\n");
+    else
+      send_to_char(ch, "Everyone below level %d is locked down.\r\n", lockdown);
+
+    // kick out anyone that is at or below our lockdown threshold.
+    LIST_ITERATOR *ch_i = newListIterator(mobile_list);
+    ITERATE_LIST(ch, ch_i) {
+      if(!charIsNPC(ch) && charGetLevel(ch) < lockdown) {
+	send_to_char(ch, "The mud has just been locked down to anyone at or "
+		     "below your level.\r\n");
+	save_player(ch);
+
+	// and close the socket if we have one
+	if(charGetSocket(ch)) {
+	  SOCKET_DATA *sock = charGetSocket(ch);
+	  charSetSocket(ch, NULL);
+	  socketSetChar(sock, NULL);
+	  close_socket(sock, FALSE);
+	}
+
+	// do the extraction
+	extract_mobile(ch);
+      }
+    } deleteListIterator(ch_i);
+  }
+}
+
+
 //
 // BOOM! Shut down the MUD
-//
 COMMAND(cmd_shutdown) {
   shut_down = TRUE;
 }
@@ -30,7 +95,6 @@
 
 //
 // Perform a command multiple times
-//
 COMMAND(cmd_repeat) {
   if(!arg || !*arg) {
     send_to_char(ch, "What did you want to repeat, and how many times?\r\n");
@@ -58,7 +122,6 @@
 
 //
 // Perform a command at another room or person
-//
 COMMAND(cmd_at) {
   if(!arg || !*arg) {
     send_to_char(ch, "Do what where?\r\n");
@@ -111,7 +174,6 @@
 //   examples:
 //     goto 100             go to room number 100
 //     goto jim             go to an object/person named jim
-//
 COMMAND(cmd_goto) {
   if(!arg || !*arg)
     send_to_char(ch, "Where would you like to go to?\r\n");
@@ -162,7 +224,6 @@
 // The opposite of goto. Instead of moving to a specified location, it
 // takes the target to the user.
 //   usage: transfer [player]
-//
 COMMAND(cmd_transfer) {
   if(!arg || !*arg)
     send_to_char(ch, "Who would you like to transfer?\r\n");
@@ -195,7 +256,6 @@
 
 //
 // Perform a copyover
-//
 COMMAND(cmd_copyover) { 
   do_copyover(ch);
 }
@@ -203,7 +263,6 @@
 
 //
 // show a list of all the PCs who are linkdead
-//
 COMMAND(cmd_linkdead) {
   CHAR_DATA *xMob;
   char buf[MAX_BUFFER];
@@ -226,7 +285,6 @@
 
 //
 // List all of the non-player commands the character has access to
-//
 COMMAND(cmd_wizhelp) {
   show_commands(ch, LEVEL_BUILDER, charGetLevel(ch));
 }
@@ -234,7 +292,6 @@
 
 //
 // Turn on/off immortal invisibility
-//
 COMMAND(cmd_invis) {
   int level = charGetLevel(ch); // default to our level
   if(arg && *arg && isdigit(*arg))
@@ -269,7 +326,6 @@
 
 //
 // turn off immortal invisibility
-//
 COMMAND(cmd_visible) {
   if(charGetImmInvis(ch) == 0)
     send_to_char(ch, "But you're already visible!\r\n");
diff -ruN ../nakedmudv2.1.1/src/cmd_misc.c src/cmd_misc.c
--- ../nakedmudv2.1.1/src/cmd_misc.c	Sun May  8 15:04:44 2005
+++ src/cmd_misc.c	Thu May 12 17:08:52 2005
@@ -57,12 +57,11 @@
   // 
   // gotta make sure we have a socket. Who knows...
   // a mobile might be trying to quit
-  //
   if(charGetSocket(ch)) {
     SOCKET_DATA *sock = charGetSocket(ch);
     charSetSocket(ch, NULL);
     socketSetChar(sock, NULL);
-    close_socket(sock, FALSE);
+    socketPopInputHandler(sock);
   }
 
   extract_mobile(ch);
@@ -114,18 +113,11 @@
   start_event(ch, atoi(time) SECONDS, event_delayed_cmd, NULL, NULL, arg);
 }
 
-
-//
-// An entrypoint into the character's notepad
 //
-/*
-COMMAND(cmd_write) {
-  if(!charGetSocket(ch))
-    send_to_char(ch, "You cannot use notepad if you have no socket.\r\n");
-  else {
-    send_around_char(ch, TRUE, "%s pulls out a notepad and begins writing.", 
-		     charGetName(ch));
-    start_notepad(charGetSocket(ch), "");
-  }
+// Displays the MOTD to the character
+COMMAND(cmd_motd) {
+  // only bother sending it if we have a socket. And then page it, incase
+  // the motd is especially long.
+  if(charGetSocket(ch))
+    page_string(charGetSocket(ch), motd);
 }
-*/
diff -ruN ../nakedmudv2.1.1/src/commands.h src/commands.h
--- ../nakedmudv2.1.1/src/commands.h	Sun May  8 15:04:44 2005
+++ src/commands.h	Thu May 12 17:08:52 2005
@@ -8,7 +8,7 @@
 //
 //*****************************************************************************
 
-/* admin.c */
+/* cmd_admin.c */
 COMMAND(cmd_goto);
 COMMAND(cmd_transfer);
 COMMAND(cmd_copyover);
@@ -19,9 +19,10 @@
 COMMAND(cmd_visible);
 COMMAND(cmd_repeat);
 COMMAND(cmd_at);
+COMMAND(cmd_lockdown);
 
 
-/* builder.c */
+/* cmd_builder.c */
 COMMAND(cmd_dig);
 COMMAND(cmd_fill);
 COMMAND(cmd_load);
@@ -75,6 +76,7 @@
 COMMAND(cmd_more);
 COMMAND(cmd_back);
 COMMAND(cmd_stop);
+COMMAND(cmd_motd);
 
 
 /* inform.c */
diff -ruN ../nakedmudv2.1.1/src/gameloop.c src/gameloop.c
--- ../nakedmudv2.1.1/src/gameloop.c	Sun May  8 15:04:44 2005
+++ src/gameloop.c	Thu May 12 17:15:17 2005
@@ -3,6 +3,8 @@
 //
 // contains the entrypoint for the MUD, plus various state-handling functions.
 //*****************************************************************************
+#include <sys/time.h>
+
 #include "mud.h"
 #include "socket.h"
 #include "world.h"
@@ -50,6 +52,8 @@
 #include "alias/alias.h"
 #endif
 
+
+
 /* local procedures */
 void game_loop    ( int control );
 bool gameloop_end = FALSE;
@@ -223,7 +227,6 @@
   log_string("Initializing helpfiles.");
   init_help();
 #endif
-
 
 
 
diff -ruN ../nakedmudv2.1.1/src/hashtable.c src/hashtable.c
--- ../nakedmudv2.1.1/src/hashtable.c	Sun May  8 15:04:44 2005
+++ src/hashtable.c	Thu May 12 17:08:52 2005
@@ -38,19 +38,17 @@
 // this is a fairly simple hashing function. It could do 
 // with some major speeding up.
 int hash(const char *key) {
-  int i;
   const int BASE = 2;
   int base = 1;
-  int len = strlen(key);
   int hvalue = 0;
 
-  for (i = 0; i < len; i++) {
+  for (; *key; key++) {
     base *= BASE;
-    hvalue += tolower(key[i]) * base;
+    hvalue += tolower(*key) * base;
   }
 
   return (hvalue < 0 ? hvalue * -1 : hvalue);
-};
+}
 
 
 //
@@ -156,8 +154,7 @@
   free(table->buckets);
 
   // now, make new buckets and set them to NULL
-  table->buckets = malloc(sizeof(LIST *) * size);
-  bzero(table->buckets, sizeof(LIST *) * size);
+  table->buckets = calloc(size, sizeof(LIST *));
   table->num_buckets = size;
 
   // now, we put all of our entries back into the new buckets
diff -ruN ../nakedmudv2.1.1/src/inform.c src/inform.c
--- ../nakedmudv2.1.1/src/inform.c	Sun May  8 15:04:44 2005
+++ src/inform.c	Thu May 12 17:08:52 2005
@@ -305,7 +305,8 @@
     send_to_char(ch, "%-30s %s\r\n", 
 		 posbuf, objGetName(equipment));
   }
-  if(bodyparts) free(bodyparts);
+  if(bodyparts) 
+    free(bodyparts);
 }
 
 
@@ -579,6 +580,7 @@
 // list all of the equipment a character is wearing to him or herself
 //
 COMMAND(cmd_equipment) {
+  send_to_char(ch, "You are wearing:\r\n");
   show_body(ch, charGetBody(ch));
 }
 
@@ -608,7 +610,6 @@
 
 //
 // show the player all of the people who are currently playing
-//
 COMMAND(cmd_who)
 {
   CHAR_DATA *plr;
@@ -622,9 +623,9 @@
 	  "{gLevel    Race )\r\n"
 	  );
 
+  // build our list of people online
   ITERATE_LIST(dsock, sock_i) {
     socket_count++;
-    //    if (dsock->state != STATE_PLAYING) continue;
     if ((plr = socketGetChar(dsock)) == NULL) continue;
     playing_count++;
     bprintf(buf, "{y%-8s %-3s  {g)  {c%-12s {b%26s\r\n", 
@@ -633,23 +634,20 @@
 	      (charGetLevel(plr) == LEVEL_SCRIPTER    ? "scripter" : "admin"))),
 	    raceGetAbbrev(charGetRace(plr)),
 	    charGetName(plr), socketGetHostname(dsock));
-  }
+  } deleteListIterator(sock_i);
 
-  bprintf(buf, "\r\n{g%d character%s connected. %d playing.\r\n",
+  // send out info about the number of sockets and players logged on
+  bprintf(buf, "\r\n{g%d socket%s connected. %d playing.\r\n",
 	  socket_count, (socket_count == 1 ? "" : "s"), playing_count);
   page_string(charGetSocket(ch), bufferString(buf));
-  //  send_to_char(ch, buf->data);
   deleteBuffer(buf);
-  deleteListIterator(sock_i);
 }
 
 
 
 //*****************************************************************************
-//
 // below this line are all of the subfunctions related to the message() 
 // function
-//
 //*****************************************************************************
 
 //
@@ -669,7 +667,6 @@
 //  $O = vobj name
 //  $a = a/an of obj
 //  $A = a/an of vobj
-//
 void send_message(CHAR_DATA *to, 
 		  const char *str,
 		  CHAR_DATA *ch, CHAR_DATA *vict,
@@ -812,5 +809,19 @@
       send_message(rec, mssg, ch, vict, obj, vobj);
     }
     deleteListIterator(rec_i);
+  }
+}
+
+void mssgprintf(CHAR_DATA *ch, CHAR_DATA *vict, 
+		OBJ_DATA *obj, OBJ_DATA  *vobj,
+		int hide_nosee, bitvector_t range, const char *fmt, ...) {
+  if(fmt && *fmt) {
+    // form the message
+    static char buf[MAX_BUFFER];
+    va_list args;
+    va_start(args, fmt);
+    vsprintf(buf, fmt, args);
+    va_end(args);
+    message(ch, vict, obj, vobj, hide_nosee, range, buf);
   }
 }
diff -ruN ../nakedmudv2.1.1/src/inform.h src/inform.h
--- ../nakedmudv2.1.1/src/inform.h	Sun May  8 15:04:44 2005
+++ src/inform.h	Thu May 12 17:08:52 2005
@@ -46,6 +46,12 @@
 	     int hide_nosee, bitvector_t range, 
 	     const char *mssg);
 
+//
+// same deal as message(), but takes a formatting
+void mssgprintf(CHAR_DATA *ch, CHAR_DATA *vict, 
+		OBJ_DATA *obj, OBJ_DATA  *vobj,
+		int hide_nosee, bitvector_t range, const char *fmt, ...)
+  __attribute__ ((format (printf, 7, 8)));
 
 //
 // send a message to everyone outdoors
diff -ruN ../nakedmudv2.1.1/src/interpret.c src/interpret.c
--- ../nakedmudv2.1.1/src/interpret.c	Sun May  8 15:04:44 2005
+++ src/interpret.c	Thu May 12 17:08:52 2005
@@ -56,11 +56,11 @@
   for(i = 0; i < 26; i++)
     cmd_table[i] = newList();
 
-  //***********************************************************************
+  //************************************************************************
   // This is for core functions ONLY! If you have a module that adds new
   // functions to the MUD, they should be added in the init_xxx() function
   // associated with your module.
-  //***********************************************************************
+  //************************************************************************
   add_cmd("north", "n", cmd_move,     DIR_NORTH,    POS_STANDING, POS_FLYING,
 	  LEVEL_PLAYER, TRUE, TRUE );
   add_cmd("east",  "e", cmd_move,     DIR_EAST,     POS_STANDING, POS_FLYING,
@@ -103,10 +103,6 @@
 	  LEVEL_PLAYER, TRUE, FALSE);
   add_cmd("buildwalk",  NULL, cmd_buildwalk, 0, POS_UNCONCIOUS, POS_FLYING,
 	  LEVEL_BUILDER, FALSE, FALSE);
-  /*
-  add_cmd("buildwalk",  NULL, cmd_tog_prf,  PRF_BUILDWALK, 
-	  POS_UNCONCIOUS, POS_FLYING, LEVEL_BUILDER, FALSE, FALSE);
-  */
 
   // C
   add_cmd("chat",       NULL, cmd_chat,     0, POS_UNCONCIOUS, POS_FLYING,
@@ -179,6 +175,8 @@
 	  LEVEL_BUILDER, FALSE, FALSE);
   add_cmd("linkdead",   NULL, cmd_linkdead, 0, POS_UNCONCIOUS, POS_FLYING,
 	  LEVEL_ADMIN, FALSE, FALSE);
+  add_cmd("lockdown",   NULL, cmd_lockdown, 0, POS_UNCONCIOUS, POS_FLYING,
+	  LEVEL_ADMIN, FALSE, FALSE);
 
   // M
   add_cmd("mlist",      NULL, cmd_mlist,    0, POS_UNCONCIOUS, POS_FLYING,
@@ -186,6 +184,8 @@
   add_cmd("mdelete",    NULL, cmd_mdelete,  0, POS_UNCONCIOUS, POS_FLYING,
 	  LEVEL_BUILDER, FALSE, FALSE);
   add_cmd("more",       NULL, cmd_more,     0, POS_UNCONCIOUS, POS_FLYING,
+	  LEVEL_PLAYER, TRUE, FALSE);
+  add_cmd("motd",       NULL, cmd_motd,     0, POS_UNCONCIOUS, POS_FLYING,
 	  LEVEL_PLAYER, TRUE, FALSE);
 
   // O
diff -ruN ../nakedmudv2.1.1/src/list.c src/list.c
--- ../nakedmudv2.1.1/src/list.c	Sun May  8 15:04:44 2005
+++ src/list.c	Thu May 12 17:08:52 2005
@@ -147,8 +147,8 @@
 }
 
 void listPut(LIST *L, void *elem) {
-  if(listIn(L, elem))
-    return;
+  //  if(listIn(L, elem))
+  //    return;
 
   LIST_NODE *N = newListNode(elem);
   N->next = L->head;
@@ -160,8 +160,8 @@
 
 
 void listQueue(LIST *L, void *elem) {
-  if(listIn(L, elem))
-    return;
+  //  if(listIn(L, elem))
+  //    return;
 
   LIST_NODE *N = newListNode(elem);
 
diff -ruN ../nakedmudv2.1.1/src/map.c src/map.c
--- ../nakedmudv2.1.1/src/map.c	Sun May  8 15:04:45 2005
+++ src/map.c	Thu May 12 17:08:52 2005
@@ -10,6 +10,11 @@
 #include "list.h"
 #include "map.h"
 
+
+// how big of a size does our map start out at?
+#define DEFAULT_MAP_SIZE        5
+
+
 int gen_hash_cmp(const void *key1, const void *key2) {
   int val = (key2 - key1);
   if(val < 0)      return -1;
@@ -31,11 +36,12 @@
 };
 
 typedef struct map_entry {
-  void *key;
+  const void *key;
   void *val;
 } MAP_ENTRY;
 
 struct map_data {
+  int size;
   int num_buckets;
   struct list **buckets;
   int (* hash_func)(const void *key);
@@ -46,7 +52,7 @@
 //
 // an internal form of hashGet that returns the entire entry (key and val)
 //
-MAP_ENTRY *mapGetEntry(MAP *map, void *key) {
+MAP_ENTRY *mapGetEntry(MAP *map, const void *key) {
   int bucket = map->hash_func(key) % map->num_buckets;
 
   if(map->buckets[bucket] == NULL)
@@ -65,7 +71,7 @@
 }
 
 
-MAP_ENTRY *newMapEntry(void *key, void *val) {
+MAP_ENTRY *newMapEntry(const void *key, void *val) {
   MAP_ENTRY *entry = malloc(sizeof(MAP_ENTRY));
   entry->key = key;
   entry->val = val;
@@ -77,20 +83,68 @@
 }
 
 
+//
+// Collect all of the MAP_ENTRYs in a map into a single list
+LIST *mapCollectEntries(MAP *map) {
+  LIST *list = newList();
+  int i;
+  for(i = 0; i < map->num_buckets; i++) {
+    if(map->buckets[i] == NULL) continue;
+    LIST_ITERATOR *list_i = newListIterator(map->buckets[i]);
+    MAP_ENTRY       *elem = NULL;
+    for(;(elem=listIteratorCurrent(list_i)) != NULL;listIteratorNext(list_i))
+      listPut(list, elem);
+    deleteListIterator(list_i);
+  }
+  return list;
+}
+
+
+//
+// expand a map to the new size
+void mapExpand(MAP *map, int size) {
+  // collect all of the key:value pairs
+  LIST     *entries = mapCollectEntries(map);
+  MAP_ENTRY  *entry = NULL;
+  int i;
+
+  // delete all of the current buckets
+  for(i = 0; i < map->num_buckets; i++) {
+    if(map->buckets[i] == NULL) continue;
+    deleteList(map->buckets[i]);
+  }
+  free(map->buckets);
+
+  // now, make new buckets and set them to NULL
+  map->buckets = calloc(size, sizeof(LIST *));
+  map->num_buckets = size;
+
+  // now, we put all of our entries back into the new buckets
+  while((entry = listPop(entries)) != NULL) {
+    int bucket = map->hash_func(entry->key) % map->num_buckets;
+    if(map->buckets[bucket] == NULL) map->buckets[bucket] = newList();
+    listPut(map->buckets[bucket], entry);
+  }
+  deleteList(entries);
+}
+
+
+
 //*****************************************************************************
 //
-// implementation of hashmap.h
-// documentation in hashmap.h
+// implementation of map.h
+// documentation found in map.h
 //
 //*****************************************************************************
-MAP *newMap(void *hash_func, void *compares, int num_buckets) {
+MAP *newMap(void *hash_func, void *compares) {
   int i;
   MAP *map = malloc(sizeof(MAP));
-  map->num_buckets = num_buckets;
+  map->size        = 0;
+  map->num_buckets = DEFAULT_MAP_SIZE;
   map->hash_func   = (hash_func ? hash_func : gen_hash_func);
   map->compares    = (compares  ? compares  : gen_hash_cmp);
-  map->buckets = malloc(sizeof(struct list *) * num_buckets);
-  for(i = 0; i < num_buckets; i++)
+  map->buckets = malloc(sizeof(LIST *) * map->num_buckets);
+  for(i = 0; i < map->num_buckets; i++)
     map->buckets[i] = NULL;
   return map;
 }
@@ -100,7 +154,7 @@
   for(i = 0; i < map->num_buckets; i++) {
     if(map->buckets[i]) {
       MAP_ENTRY *entry = NULL;
-      while((entry=(MAP_ENTRY *)listPop(map->buckets[i])) !=NULL)
+      while((entry = listPop(map->buckets[i])) !=NULL)
 	deleteMapEntry(entry);
       deleteList(map->buckets[i]);
     }
@@ -109,7 +163,7 @@
   free(map);
 }
 
-int  mapPut    (MAP *map, void *key, void *val) {
+int  mapPut    (MAP *map, const void *key, void *val) {
   MAP_ENTRY *elem = mapGetEntry(map, key);
 
   // update the val if it's already here
@@ -118,6 +172,10 @@
     return 1;
   }
   else {
+    // first, see if we'll need to expand the map
+    if((map->size * 80)/100 > map->num_buckets)
+      mapExpand(map, (map->num_buckets * 150)/100);
+
     int bucket = map->hash_func(key) % map->num_buckets;
 
     // if the bucket doesn't exist yet, create it
@@ -126,11 +184,12 @@
 
     MAP_ENTRY *entry = newMapEntry(key, val);
     listPut(map->buckets[bucket], entry);
+    map->size++;
     return 1;
   }
 }
 
-void *mapGet    (MAP *map, void *key) {
+void *mapGet    (MAP *map, const void *key) {
   MAP_ENTRY *elem = mapGetEntry(map, key);
   if(elem)
     return elem->val;
@@ -138,7 +197,7 @@
     return NULL;
 }
 
-void *mapRemove (MAP *map, void *key) {
+void *mapRemove (MAP *map, const void *key) {
   int bucket = map->hash_func(key) % map->num_buckets;
 
   if(map->buckets[bucket] == NULL)
@@ -156,6 +215,7 @@
       void *val = elem->val;
       listRemove(map->buckets[bucket], elem);
       deleteMapEntry(elem);
+      map->size--;
       return val;
     }
     else
@@ -163,19 +223,12 @@
   }
 }
 
-int   mapIn     (MAP *map, void *key) {
+int   mapIn     (MAP *map, const void *key) {
   return (mapGet(map, key) != NULL);
 }
 
 int   mapSize   (MAP *map) {
-  int i;
-  int size = 0;
-
-  for(i = 0; i < map->num_buckets; i++)
-    if(map->buckets[i])
-      size += listSize(map->buckets[i]);
-
-  return size;
+  return map->size;
 }
 
 
@@ -238,7 +291,7 @@
   }
 }
 
-void *mapIteratorCurrentKey (MAP_ITERATOR *I) {
+const void *mapIteratorCurrentKey(MAP_ITERATOR *I) {
   if(!I->bucket_i)
     return NULL;
   else {
